diff --git a/src/backend/utils/sort/sharedtuplestore.c b/src/backend/utils/sort/sharedtuplestore.c
index 7765a445c0..8365254fc4 100644
--- a/src/backend/utils/sort/sharedtuplestore.c
+++ b/src/backend/utils/sort/sharedtuplestore.c
@@ -59,10 +59,11 @@ typedef struct SharedTuplestoreParticipant
 /* The control object that lives in shared memory. */
 struct SharedTuplestore
 {
-	int			nparticipants;	/* Number of participants that can write. */
-	int			flags;			/* Flag bits from SHARED_TUPLESTORE_XXX */
-	size_t		meta_data_size; /* Size of per-tuple header. */
-	char		name[NAMEDATALEN];	/* A name for this tuplestore. */
+	int              nparticipants;	/* Number of participants that can write. */
+	pg_atomic_uint32 ntuples; // TODO: does this belong elsewhere
+	int              flags;			/* Flag bits from SHARED_TUPLESTORE_XXX */
+	size_t           meta_data_size; /* Size of per-tuple header. */
+	char             name[NAMEDATALEN];	/* A name for this tuplestore. */
 
 	/* Followed by per-participant shared state. */
 	SharedTuplestoreParticipant participants[FLEXIBLE_ARRAY_MEMBER];
@@ -92,10 +93,15 @@ struct SharedTuplestoreAccessor
 	BlockNumber write_page;		/* The next page to write to. */
 	char	   *write_pointer;	/* Current write pointer within chunk. */
 	char	   *write_end;		/* One past the end of the current chunk. */
+
+	/* Bitmap of matched outer tuples (currently only used for hashjoin). */
+	BufFile    *outer_match_status_file;
 };
 
 static void sts_filename(char *name, SharedTuplestoreAccessor *accessor,
 						 int participant);
+static void
+sts_bitmap_filename(char *name, SharedTuplestoreAccessor *accessor, int participant);
 
 /*
  * Return the amount of shared memory required to hold SharedTuplestore for a
@@ -137,6 +143,7 @@ sts_initialize(SharedTuplestore *sts, int participants,
 	Assert(my_participant_number < participants);
 
 	sts->nparticipants = participants;
+	pg_atomic_init_u32(&sts->ntuples, 1);
 	sts->meta_data_size = meta_data_size;
 	sts->flags = flags;
 
@@ -166,6 +173,7 @@ sts_initialize(SharedTuplestore *sts, int participants,
 	accessor->sts = sts;
 	accessor->fileset = fileset;
 	accessor->context = CurrentMemoryContext;
+	accessor->outer_match_status_file = NULL;
 
 	return accessor;
 }
@@ -343,6 +351,7 @@ sts_puttuple(SharedTuplestoreAccessor *accessor, void *meta_data,
 			sts_flush_chunk(accessor);
 		}
 
+		// TODO: exercise this code with a test (over-sized tuple)
 		/* It may still not be enough in the case of a gigantic tuple. */
 		if (accessor->write_pointer + size >= accessor->write_end)
 		{
@@ -621,6 +630,116 @@ sts_parallel_scan_next(SharedTuplestoreAccessor *accessor, void *meta_data)
 	return NULL;
 }
 
+// TODO: fix signedness
+int sts_increment_tuplenum(SharedTuplestoreAccessor *accessor)
+{
+	return pg_atomic_fetch_add_u32(&accessor->sts->ntuples, 1);
+}
+
+void
+sts_make_outer_match_status_file(SharedTuplestoreAccessor *accessor)
+{
+	uint32 tuplenum = pg_atomic_read_u32(&accessor->sts->ntuples);
+	/* don't make the outer match status file if there are no tuples */
+	if (tuplenum == 0)
+		return;
+
+	char name[MAXPGPATH];
+	sts_bitmap_filename(name, accessor, accessor->participant);
+
+	accessor->outer_match_status_file = BufFileCreateShared(accessor->fileset, name);
+
+	// TODO: check this math. tuplenumber will be too high.
+	uint32 num_to_write = tuplenum / 8 + 1;
+
+	unsigned char byteToWrite = 0;
+	BufFileWrite(accessor->outer_match_status_file, &byteToWrite, num_to_write);
+
+	if (BufFileSeek(accessor->outer_match_status_file, 0, 0L, SEEK_SET))
+		ereport(ERROR,
+		        (errcode_for_file_access(),
+			        errmsg("could not rewind hash-join temporary file: %m")));
+}
+
+void
+sts_set_outer_match_status(SharedTuplestoreAccessor *accessor, uint32 tuplenum)
+{
+	BufFile *parallel_outer_matchstatuses = accessor->outer_match_status_file;
+	unsigned char current_outer_byte;
+
+	BufFileSeek(parallel_outer_matchstatuses, 0, tuplenum / 8, SEEK_SET);
+	BufFileRead(parallel_outer_matchstatuses, &current_outer_byte, 1);
+
+	current_outer_byte |= 1U << (tuplenum % 8);
+
+	if (BufFileSeek(parallel_outer_matchstatuses, 0, -1, SEEK_CUR) != 0)
+		elog(ERROR, "there is a problem with outer match status file. pid %i.", MyProcPid);
+	BufFileWrite(parallel_outer_matchstatuses, &current_outer_byte, 1);
+}
+
+void
+sts_close_outer_match_status_file(SharedTuplestoreAccessor *accessor)
+{
+	BufFileClose(accessor->outer_match_status_file);
+}
+
+BufFile *sts_combine_outer_match_status_files(SharedTuplestoreAccessor *accessor)
+{
+	// TODO: this tries to close an outer match status file for
+	// each participant in the tuplestore. technically, only participants
+	// in the barrier could have outer match status files, however,
+	// all but one participant continue on and detach from the barrier
+	// so we won't have a reliable way to close only files for those attached
+	// to the barrier
+	BufFile **statuses = palloc(sizeof(BufFile *) * accessor->sts->nparticipants);
+
+	// Open the bitmap shared BufFile from each participant. TODO: explain why file can be NULLs
+	int statuses_length = 0;
+	for (int i = 0; i < accessor->sts->nparticipants; i++)
+	{
+		char bitmap_filename[MAXPGPATH];
+		sts_bitmap_filename(bitmap_filename, accessor, i);
+		BufFile *file = BufFileOpenSharedIfExists(accessor->fileset, bitmap_filename);
+
+		if (file != NULL)
+			statuses[statuses_length++] = file;
+	}
+
+	BufFile *combined_bitmap_file = BufFileCreateTemp(false);
+
+	for (int64 cur = 0; cur < BufFileSize(statuses[0]); cur++) // make it while not EOF
+	{
+		unsigned char combined_byte = 0;
+
+		for (int i = 0; i < statuses_length; i++)
+		{
+			unsigned char read_byte;
+			BufFileRead(statuses[i], &read_byte, 1);
+			combined_byte |= read_byte;
+		}
+
+		BufFileWrite(combined_bitmap_file, &combined_byte, 1);
+	}
+
+	if (BufFileSeek(combined_bitmap_file, 0, 0L, SEEK_SET))
+		ereport(ERROR,
+		        (errcode_for_file_access(),
+			        errmsg("could not rewind hash-join temporary file: %m")));
+
+	for (int i = 0; i < statuses_length; i++)
+		BufFileClose(statuses[i]);
+	pfree(statuses);
+
+	return combined_bitmap_file;
+}
+
+
+static void
+sts_bitmap_filename(char *name, SharedTuplestoreAccessor *accessor, int participant)
+{
+	snprintf(name, MAXPGPATH, "%s.p%d.bitmap", accessor->sts->name, participant);
+}
+
 /*
  * Create the name used for the BufFile that a given participant will write.
  */
diff --git a/src/include/executor/adaptiveHashjoin.h b/src/include/executor/adaptiveHashjoin.h
new file mode 100644
index 0000000000..ee189f5e2b
--- /dev/null
+++ b/src/include/executor/adaptiveHashjoin.h
@@ -0,0 +1,9 @@
+#ifndef ADAPTIVE_HASHJOIN_H
+#define ADAPTIVE_HASHJOIN_H
+
+
+extern bool ExecParallelHashJoinNewChunk(HashJoinState *hjstate, bool advance_from_probing);
+extern bool ExecParallelHashJoinNewBatch(HashJoinState *hjstate);
+
+
+#endif /* ADAPTIVE_HASHJOIN_H */
diff --git a/src/include/executor/hashjoin.h b/src/include/executor/hashjoin.h
index 2c94b926d3..4500300356 100644
--- a/src/include/executor/hashjoin.h
+++ b/src/include/executor/hashjoin.h
@@ -148,17 +148,32 @@ typedef struct HashMemoryChunkData *HashMemoryChunk;
  * followed by variable-sized objects, they are arranged in contiguous memory
  * but not accessed directly as an array.
  */
+// TODO: maybe remove lock from ParallelHashJoinBatch and use pstate->lock
+// and the PHJBatchAccessor to coordinate access to the PHJ batch similar to
+// other users of that lock
 typedef struct ParallelHashJoinBatch
 {
 	dsa_pointer buckets;		/* array of hash table buckets */
 	Barrier		batch_barrier;	/* synchronization for joining this batch */
 
+	/* Parallel Adaptive Hash Join members */
+	/*
+	 * after finishing build phase, parallel_hashloop_fallback cannot change,
+	 * and does not require a lock to read
+	 */
+	bool    parallel_hashloop_fallback;
+	int     total_num_chunks;
+	int     current_chunk_num;
+	size_t  estimated_chunk_size;
+	Barrier chunk_barrier;
+	LWLock  lock;
+
 	dsa_pointer chunks;			/* chunks of tuples loaded */
 	size_t		size;			/* size of buckets + chunks in memory */
 	size_t		estimated_size; /* size of buckets + chunks while writing */
 	size_t		ntuples;		/* number of tuples loaded */
 	size_t		old_ntuples;	/* number of tuples before repartitioning */
-	bool		space_exhausted;
+	bool    space_exhausted;
 
 	/*
 	 * Variable-sized SharedTuplestore objects follow this struct in memory.
@@ -243,6 +258,7 @@ typedef struct ParallelHashJoinState
 	int			nparticipants;
 	size_t		space_allowed;
 	size_t		total_tuples;	/* total number of inner tuples */
+	int batch_increases; // TODO: make this an atomic so I don't need the lock to increment it?
 	LWLock		lock;			/* lock protecting the above */
 
 	Barrier		build_barrier;	/* synchronization for the build phases */
@@ -263,10 +279,16 @@ typedef struct ParallelHashJoinState
 /* The phases for probing each batch, used by for batch_barrier. */
 #define PHJ_BATCH_ELECTING				0
 #define PHJ_BATCH_ALLOCATING			1
-#define PHJ_BATCH_LOADING				2
-#define PHJ_BATCH_PROBING				3
+#define PHJ_BATCH_CHUNKING				2
+#define PHJ_BATCH_OUTER_MATCH_STATUS_PROCESSING 3
 #define PHJ_BATCH_DONE					4
 
+#define PHJ_CHUNK_ELECTING				0
+#define PHJ_CHUNK_LOADING				1
+#define PHJ_CHUNK_PROBING				2
+#define PHJ_CHUNK_DONE					3
+#define PHJ_CHUNK_FINAL					4
+
 /* The phases of batch growth while hashing, for grow_batches_barrier. */
 #define PHJ_GROW_BATCHES_ELECTING		0
 #define PHJ_GROW_BATCHES_ALLOCATING		1
diff --git a/src/include/executor/nodeHash.h b/src/include/executor/nodeHash.h
index fc80f03aa8..39500f755c 100644
--- a/src/include/executor/nodeHash.h
+++ b/src/include/executor/nodeHash.h
@@ -40,9 +40,8 @@ extern void ExecHashTableInsert(HashJoinTable hashtable,
 extern void ExecParallelHashTableInsert(HashJoinTable hashtable,
 										TupleTableSlot *slot,
 										uint32 hashvalue);
-extern void ExecParallelHashTableInsertCurrentBatch(HashJoinTable hashtable,
-													TupleTableSlot *slot,
-													uint32 hashvalue);
+extern void
+ExecParallelHashTableInsertCurrentBatch(HashJoinTable hashtable, TupleTableSlot *slot, uint32 hashvalue);
 extern bool ExecHashGetHashValue(HashJoinTable hashtable,
 								 ExprContext *econtext,
 								 List *hashkeys,
diff --git a/src/include/executor/tuptable.h b/src/include/executor/tuptable.h
index 04feaba55d..e2e7d0a58c 100644
--- a/src/include/executor/tuptable.h
+++ b/src/include/executor/tuptable.h
@@ -129,6 +129,7 @@ typedef struct TupleTableSlot
 	MemoryContext tts_mcxt;		/* slot itself is in this context */
 	ItemPointerData tts_tid;	/* stored tuple's tid */
 	Oid			tts_tableOid;	/* table oid of tuple */
+	uint32 		tuplenum;
 } TupleTableSlot;
 
 /* routines for a TupleTableSlot implementation */
@@ -425,7 +426,7 @@ static inline TupleTableSlot *
 ExecClearTuple(TupleTableSlot *slot)
 {
 	slot->tts_ops->clear(slot);
-
+	slot->tuplenum = 0;
 	return slot;
 }
 
diff --git a/src/include/nodes/execnodes.h b/src/include/nodes/execnodes.h
index 0c2a77aaf8..e569cea3c2 100644
--- a/src/include/nodes/execnodes.h
+++ b/src/include/nodes/execnodes.h
@@ -14,6 +14,7 @@
 #ifndef EXECNODES_H
 #define EXECNODES_H
 
+#include <storage/buffile.h>
 #include "access/tupconvert.h"
 #include "executor/instrument.h"
 #include "fmgr.h"
@@ -1943,6 +1944,22 @@ typedef struct HashJoinState
 	int			hj_JoinState;
 	bool		hj_MatchedOuter;
 	bool		hj_OuterNotEmpty;
+
+	/* hashloop fallback */
+	bool hashloop_fallback;
+	/* hashloop fallback inner side */
+	bool hj_InnerFirstChunk;
+	bool hj_InnerExhausted;
+	off_t hj_InnerPageOffset;
+
+	/* hashloop fallback outer side */
+	unsigned char hj_OuterCurrentByte;
+	BufFile *hj_OuterMatchStatusesFile; /* serial AHJ */
+	int64 hj_OuterTupleCount;
+
+	/* parallel hashloop fallback outer side */
+	bool last_worker;
+	BufFile *combined_bitmap;
 } HashJoinState;
 
 
diff --git a/src/include/pgstat.h b/src/include/pgstat.h
index f2e873d048..c117a16d43 100644
--- a/src/include/pgstat.h
+++ b/src/include/pgstat.h
@@ -815,6 +815,7 @@ typedef enum
  * it is waiting for a notification from another process.
  * ----------
  */
+// TODO: add WAIT_EVENT_HASH_BUILD_CREATE_OUTER_MATCH_STATUS_BITMAP_FILES?
 typedef enum
 {
 	WAIT_EVENT_BGWORKER_SHUTDOWN = PG_WAIT_IPC,
@@ -827,10 +828,12 @@ typedef enum
 	WAIT_EVENT_HASH_BATCH_ALLOCATING,
 	WAIT_EVENT_HASH_BATCH_ELECTING,
 	WAIT_EVENT_HASH_BATCH_LOADING,
+	WAIT_EVENT_HASH_BATCH_PROBING,
 	WAIT_EVENT_HASH_BUILD_ALLOCATING,
 	WAIT_EVENT_HASH_BUILD_ELECTING,
 	WAIT_EVENT_HASH_BUILD_HASHING_INNER,
 	WAIT_EVENT_HASH_BUILD_HASHING_OUTER,
+	WAIT_EVENT_HASH_BUILD_CREATE_OUTER_MATCH_STATUS_BITMAP_FILES,
 	WAIT_EVENT_HASH_GROW_BATCHES_ALLOCATING,
 	WAIT_EVENT_HASH_GROW_BATCHES_DECIDING,
 	WAIT_EVENT_HASH_GROW_BATCHES_ELECTING,
@@ -839,6 +842,11 @@ typedef enum
 	WAIT_EVENT_HASH_GROW_BUCKETS_ALLOCATING,
 	WAIT_EVENT_HASH_GROW_BUCKETS_ELECTING,
 	WAIT_EVENT_HASH_GROW_BUCKETS_REINSERTING,
+	WAIT_EVENT_HASH_CHUNK_ELECTING,
+	WAIT_EVENT_HASH_CHUNK_LOADING,
+	WAIT_EVENT_HASH_CHUNK_PROBING,
+	WAIT_EVENT_HASH_CHUNK_DONE,
+	WAIT_EVENT_HASH_ADVANCE_CHUNK,
 	WAIT_EVENT_LOGICAL_SYNC_DATA,
 	WAIT_EVENT_LOGICAL_SYNC_STATE_CHANGE,
 	WAIT_EVENT_MQ_INTERNAL,
diff --git a/src/include/storage/barrier.h b/src/include/storage/barrier.h
index 1903897eef..7c578d3935 100644
--- a/src/include/storage/barrier.h
+++ b/src/include/storage/barrier.h
@@ -36,6 +36,7 @@ typedef struct Barrier
 
 extern void BarrierInit(Barrier *barrier, int num_workers);
 extern bool BarrierArriveAndWait(Barrier *barrier, uint32 wait_event_info);
+extern bool BarrierArriveExplicitAndWait(Barrier *barrier, int next_phase, uint32 wait_event_info);
 extern bool BarrierArriveAndDetach(Barrier *barrier);
 extern int	BarrierAttach(Barrier *barrier);
 extern bool BarrierDetach(Barrier *barrier);
diff --git a/src/include/storage/buffile.h b/src/include/storage/buffile.h
index 1fba404fe2..6539dc34bb 100644
--- a/src/include/storage/buffile.h
+++ b/src/include/storage/buffile.h
@@ -48,7 +48,10 @@ extern long BufFileAppend(BufFile *target, BufFile *source);
 
 extern BufFile *BufFileCreateShared(SharedFileSet *fileset, const char *name);
 extern void BufFileExportShared(BufFile *file);
+extern BufFile *BufFileOpenSharedIfExists(SharedFileSet *fileset, const char *name);
 extern BufFile *BufFileOpenShared(SharedFileSet *fileset, const char *name);
 extern void BufFileDeleteShared(SharedFileSet *fileset, const char *name);
 
+extern BufFile *BufFileRewindIfExists(BufFile *bufFile);
+
 #endif							/* BUFFILE_H */
diff --git a/src/include/storage/lwlock.h b/src/include/storage/lwlock.h
index f9450dac90..f2575d024f 100644
--- a/src/include/storage/lwlock.h
+++ b/src/include/storage/lwlock.h
@@ -212,6 +212,7 @@ typedef enum BuiltinTrancheIds
 	LWTRANCHE_LOCK_MANAGER,
 	LWTRANCHE_PREDICATE_LOCK_MANAGER,
 	LWTRANCHE_PARALLEL_HASH_JOIN,
+	LWTRANCHE_PARALLEL_HASH_JOIN_BATCH,
 	LWTRANCHE_PARALLEL_QUERY_DSA,
 	LWTRANCHE_SESSION_DSA,
 	LWTRANCHE_SESSION_RECORD_TABLE,
diff --git a/src/include/utils/sharedtuplestore.h b/src/include/utils/sharedtuplestore.h
index 9dea626e84..23768683fc 100644
--- a/src/include/utils/sharedtuplestore.h
+++ b/src/include/utils/sharedtuplestore.h
@@ -22,6 +22,16 @@ typedef struct SharedTuplestore SharedTuplestore;
 
 struct SharedTuplestoreAccessor;
 typedef struct SharedTuplestoreAccessor SharedTuplestoreAccessor;
+struct tupleMetadata;
+typedef struct tupleMetadata tupleMetadata;
+// TODO: conflicting types for tupleid with accessor->sts->ntuples (uint32)
+// TODO: use a union for tupleid (uint32) (make this a uint64) and chunk number (int)
+struct tupleMetadata
+{
+	uint32 hashvalue;
+	int tupleid; /* tuple id on outer side and chunk number for inner side */
+} __attribute__((packed));
+// TODO: make sure I can get rid of packed now that using sizeof(struct)
 
 /*
  * A flag indicating that the tuplestore will only be scanned once, so backing
@@ -58,4 +68,13 @@ extern void sts_puttuple(SharedTuplestoreAccessor *accessor,
 extern MinimalTuple sts_parallel_scan_next(SharedTuplestoreAccessor *accessor,
 										   void *meta_data);
 
+
+extern int sts_increment_tuplenum(SharedTuplestoreAccessor *accessor);
+
+extern void sts_make_outer_match_status_file(SharedTuplestoreAccessor *accessor);
+extern void sts_set_outer_match_status(SharedTuplestoreAccessor *accessor, uint32 tuplenum);
+extern void sts_close_outer_match_status_file(SharedTuplestoreAccessor *accessor);
+extern BufFile *sts_combine_outer_match_status_files(SharedTuplestoreAccessor *accessor);
+
+
 #endif							/* SHAREDTUPLESTORE_H */
diff --git a/src/test/regress/parallel_schedule b/src/test/regress/parallel_schedule
index d33a4e143d..0afd6db491 100644
--- a/src/test/regress/parallel_schedule
+++ b/src/test/regress/parallel_schedule
@@ -78,7 +78,7 @@ test: brin gin gist spgist privileges init_privs security_label collate matview
 # ----------
 # Another group of parallel tests
 # ----------
-test: create_table_like alter_generic alter_operator misc async dbsize misc_functions sysviews tsrf tidscan collate.icu.utf8
+test: create_table_like alter_generic alter_operator misc async dbsize misc_functions sysviews tsrf tidscan collate.icu.utf8 adaptive_hj parallel_adaptive_hj
 
 # rules cannot run concurrently with any test that creates
 # a view or rule in the public schema
diff --git a/src/test/regress/post_schedule b/src/test/regress/post_schedule
new file mode 100644
index 0000000000..7824ecf7bf
--- /dev/null
+++ b/src/test/regress/post_schedule
@@ -0,0 +1,8 @@
+test: object_address
+test: tablesample
+test: groupingsets
+test: drop_operator
+test: password
+test: identity
+test: generated
+test: join_hash
diff --git a/src/test/regress/pre_schedule b/src/test/regress/pre_schedule
new file mode 100644
index 0000000000..4105b0fa03
--- /dev/null
+++ b/src/test/regress/pre_schedule
@@ -0,0 +1,120 @@
+# src/test/regress/serial_schedule
+# This should probably be in an order similar to parallel_schedule.
+test: tablespace
+test: boolean
+test: char
+test: name
+test: varchar
+test: text
+test: int2
+test: int4
+test: int8
+test: oid
+test: float4
+test: float8
+test: bit
+test: numeric
+test: txid
+test: uuid
+test: enum
+test: money
+test: rangetypes
+test: pg_lsn
+test: regproc
+test: strings
+test: numerology
+test: point
+test: lseg
+test: line
+test: box
+test: path
+test: polygon
+test: circle
+test: date
+test: time
+test: timetz
+test: timestamp
+test: timestamptz
+test: interval
+test: inet
+test: macaddr
+test: macaddr8
+test: tstypes
+test: geometry
+test: horology
+test: regex
+test: oidjoins
+test: type_sanity
+test: opr_sanity
+test: misc_sanity
+test: comments
+test: expressions
+test: create_function_1
+test: create_type
+test: create_table
+test: create_function_2
+test: copy
+test: copyselect
+test: copydml
+test: insert
+test: insert_conflict
+test: create_misc
+test: create_operator
+test: create_procedure
+test: create_index
+test: create_index_spgist
+test: create_view
+test: index_including
+test: index_including_gist
+test: create_aggregate
+test: create_function_3
+test: create_cast
+test: constraints
+test: triggers
+test: select
+test: inherit
+test: typed_table
+test: vacuum
+test: drop_if_exists
+test: updatable_views
+test: roleattributes
+test: create_am
+test: hash_func
+test: errors
+test: sanity_check
+test: select_into
+test: select_distinct
+test: select_distinct_on
+test: select_implicit
+test: select_having
+test: subselect
+test: union
+test: case
+test: join
+test: adaptive_hj
+test: parallel_adaptive_hj
+test: aggregates
+test: transactions
+ignore: random
+test: random
+test: portals
+test: arrays
+test: btree_index
+test: hash_index
+test: update
+test: delete
+test: namespace
+test: prepared_xacts
+test: brin
+test: gin
+test: gist
+test: spgist
+test: privileges
+test: init_privs
+test: security_label
+test: collate
+test: matview
+test: lock
+test: replica_identity
+test: rowsecurity
+
diff --git a/src/test/regress/serial_schedule b/src/test/regress/serial_schedule
index f86f5c5682..0dc0967a93 100644
--- a/src/test/regress/serial_schedule
+++ b/src/test/regress/serial_schedule
@@ -91,6 +91,8 @@ test: subselect
 test: union
 test: case
 test: join
+test: adaptive_hj
+test: parallel_adaptive_hj
 test: aggregates
 test: transactions
 ignore: random
diff --git a/src/test/regress/sql/adaptive_hj.sql b/src/test/regress/sql/adaptive_hj.sql
new file mode 100644
index 0000000000..a5af798ea8
--- /dev/null
+++ b/src/test/regress/sql/adaptive_hj.sql
@@ -0,0 +1,240 @@
+-- TODO: remove some of these tests and make the test file faster
+create schema adaptive_hj;
+set search_path=adaptive_hj;
+drop table if exists t1;
+drop table if exists t2;
+create table t1(a int);
+create table t2(b int);
+
+-- serial setup
+set work_mem=64;
+set enable_mergejoin to off;
+-- TODO: make this function general
+create or replace function explain_multi_batch() returns setof text language plpgsql as
+$$
+declare ln text;
+begin
+    for ln in
+        explain (analyze, summary off, timing off, costs off)
+		select count(*) from t1 left outer join t2 on a = b
+    loop
+        ln := regexp_replace(ln, 'Memory Usage: \S*',  'Memory Usage: xxx');
+        return next ln;
+    end loop;
+end;
+$$;
+
+-- Serial_Test_1 reset
+-- TODO: refactor into procedure or change to drop table
+update pg_class set reltuples = 0, relpages = 0 where relname = 't2';
+update pg_class set reltuples = 0, relpages = 0 where relname = 't1';
+delete from pg_statistic where starelid = 't2'::regclass;
+delete from pg_statistic where starelid = 't1'::regclass;
+
+-- Serial_Test_1 setup
+truncate table t1;
+insert into t1 values(1),(2);
+insert into t1 select i from generate_series(1,10)i;
+insert into t1 select 2 from generate_series(1,5)i;
+truncate table t2;
+insert into t2 values(2),(3),(11);
+insert into t2 select i from generate_series(2,10)i;
+insert into t2 select 2 from generate_series(2,7)i;
+
+-- Serial_Test_1.1
+-- TODO: automate the checking for expected number of chunks (explain option?)
+-- spills in 4 batches
+-- batch 1 falls back with 2 chunks with no unmatched tuples
+-- batch 2 falls back with 2 chunks with 2 unmatched tuples emitted at EOB 
+-- batch 3 falls back with 5 chunks with no unmatched tuples
+-- batch 4 does not fall back with no unmatched tuples
+select * from explain_multi_batch();
+select * from t1 left outer join t2 on a = b order by b, a;
+select * from t1, t2 where a = b order by b;
+select * from t1 right outer join t2 on a = b order by a, b;
+select * from t1 full outer join t2 on a = b order by b, a;
+
+-- Serial_Test_1.2 setup
+analyze t1; analyze t2;
+
+-- Serial_Test_1.2
+-- doesn't spill (happens to do a hash right join)
+select * from explain_multi_batch();
+
+-- Serial_Test_2 reset
+update pg_class set reltuples = 0, relpages = 0 where relname = 't2';
+update pg_class set reltuples = 0, relpages = 0 where relname = 't1';
+delete from pg_statistic where starelid = 't2'::regclass;
+delete from pg_statistic where starelid = 't1'::regclass;
+
+-- Serial_Test_2 setup:
+truncate table t1;
+insert into t1 values (1),(2),(2),(3);
+truncate table t2;
+insert into t2 values(2),(2),(3),(3),(4);
+
+-- Serial_Test_2.1
+-- spills in 4 batches
+-- batch 1 falls back with 2 chunks with no unmatched tuples
+-- batch 2 does not fall back with 1 unmatched tuple
+-- batch 3 does not fall back with no unmatched tuples
+-- batch 4 does not fall back with no unmatched tuples
+select * from explain_multi_batch();
+select * from t1 left outer join t2 on a = b order by b, a;
+select * from t1 right outer join t2 on a = b order by a, b;
+
+-- TODO: check coverage for emitting ummatched inner tuples
+-- Serial_Test_2.1.a
+-- results checking for inner join
+select * from t1 left outer join t2 on a = b order by b, a;
+select * from t1, t2 where a = b order by b;
+select * from t1 right outer join t2 on a = b order by a, b;
+select * from t1 full outer join t2 on a = b order by b, a;
+select * from t1, t2 where a = b order by b;
+
+-- Serial_Test_2.2
+analyze t1; analyze t2;
+-- doesn't spill (happens to do a hash right join)
+select * from explain_multi_batch();
+
+-- Serial_Test_3 reset
+update pg_class set reltuples = 0, relpages = 0 where relname = 't2';
+update pg_class set reltuples = 0, relpages = 0 where relname = 't1';
+delete from pg_statistic where starelid = 't2'::regclass;
+delete from pg_statistic where starelid = 't1'::regclass;
+
+
+-- Serial_Test_3 setup:
+truncate table t1;
+insert into t1 values(1),(1);
+insert into t1 select 2 from generate_series(1,7)i;
+insert into t1 select i from generate_series(3,10)i;
+truncate table t2;
+insert into t2 select 2 from generate_series(1,7)i;
+insert into t2 values(3),(3);
+insert into t2 select i from generate_series(5,9)i;
+
+-- Serial_Test_3.1
+-- spills in 4 batches
+-- batch 1 falls back with 2 chunks with 1 unmatched tuple
+-- batch 2 does not fall back with 2 unmatched tuples
+-- batch 3 falls back with 4 chunks with 1 unmatched tuple
+-- batch 4 does not fall back with no unmatched tuples
+select * from explain_multi_batch();
+select * from t1 left outer join t2 on a = b order by b, a;
+select * from t1, t2 where a = b order by b;
+select * from t1 right outer join t2 on a = b order by a, b;
+select * from t1 full outer join t2 on a = b order by b, a;
+select * from t1, t2 where a = b order by b;
+
+-- Serial_Test_3.2 
+-- swap join order
+select * from t2 left outer join t1 on a = b order by a, b;
+select * from t2, t1 where a = b order by a;
+select * from t2 right outer join t1 on a = b order by b, a;
+select * from t2 full outer join t1 on a = b order by a, b;
+
+-- Serial_Test_3.3 setup
+analyze t1; analyze t2;
+
+-- Serial_Test_3.3
+-- doesn't spill
+select * from explain_multi_batch();
+
+-- Serial_Test_4 setup
+drop table t1;
+create table t1(b int);
+insert into t1 select i from generate_series(1,111)i;
+insert into t1 select 2 from generate_series(1,180)i;
+analyze t1;
+
+drop table t2;
+create table t2(a int);
+insert into t2 select i from generate_series(20,25000)i;
+insert into t2 select 2 from generate_series(1,100)i;
+analyze t2;
+update pg_class
+  set reltuples = 10, relpages = pg_relation_size('t2') / 8192
+  where relname = 't2';
+
+-- Serial_Test_4.1
+-- spills in 32 batches
+--batch 0 does not fall back with 1 unmatched outer tuple (15)
+--batch 1 falls back with 396 chunks.
+--batch 2 falls back with 402 chunks with 1 unmatched outer tuple (1)
+--batch 3 falls back with 389 chunks with 1 unmatched outer tuple (8)
+--batch 4 falls back with 409 chunks with no unmatched outer tuples
+--batch 5 falls back with 366 chunks with 1 unmatched outer tuple (4)
+--batch 6 falls back with 407 chunks with 1 unmatched outer tuple (11)
+--batch 7 falls back with 382 chunks with unmatched outer tuple (10)
+--batch 8 falls back with 413 chunks with no unmatched outer tuples
+--batch 9 falls back with 371 chunks with 1 unmatched outer tuple (3)
+--batch 10 falls back with 389 chunks with no unmatched outer tuples
+--batch 11 falls back with 408 chunks with no unmatched outer tuples
+--batch 12 falls back with 387 chunks with no unmatched outer tuples
+--batch 13 falls back with 402 chunks with 1 unmatched outer tuple (18) 
+--batch 14 falls back with 369 chunks with 1 unmatched outer tuple (9)
+--batch 15 falls back with 387 chunks with no unmatched outer tuples
+--batch 16 falls back with 365 chunks with no unmatched outer tuples
+--batch 17 falls back with 403 chunks with 2 unmatched outer tuples (14,19)
+--batch 18 falls back with 375 chunks with no unmatched outer tuples
+--batch 19 falls back with 384 chunks with no unmatched outer tuples
+--batch 20 falls back with 377 chunks with 1 unmatched outer tuple (12)
+--batch 22 falls back with 401 chunks with no unmatched outer tuples
+--batch 23 falls back with 396 chunks with no unmatched outer tuples
+--batch 24 falls back with 387 chunks with 1 unmatched outer tuple (5)
+--batch 25 falls back with 399 chunks with 1 unmatched outer tuple (7)
+--batch 26 falls back with 387 chunks.
+--batch 27 falls back with 442 chunks.
+--batch 28 falls back with 385 chunks with 1 unmatched outer tuple (17)
+--batch 29 falls back with 375 chunks.
+--batch 30 falls back with 404 chunks with 1 unmatched outer tuple (6)
+--batch 31 falls back with 396 chunks with 2 unmatched outer tuples (13,16)
+select * from explain_multi_batch();
+select count(*) from t1 left outer join t2 on a = b;
+select count(a) from t1 left outer join t2 on a = b;
+select count(*) from t1, t2 where a = b;
+-- used to give wrong results because there is a whole batch of outer which is
+-- empty and so the inner doesn't emit unmatched tuples with ROJ
+select count(*) from t1 right outer join t2 on a = b;
+select count(*) from t1 full outer join t2 on a = b; 
+
+-- Test_6 non-negligible amount of data test case
+-- TODO: doesn't finish with my code when it is set to be serial
+-- it does finish when it is parallel -- the serial version is either simply too
+-- slow or has a bug -- I tried it with less data and it did finish, so it must
+-- just be really slow
+-- inner join shouldn't even need to make the unmatched files
+-- it finishes eventually if I decrease data amount
+
+--drop table simple;
+--create table simple as
+ -- select generate_series(1, 20000) AS id, 'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa';
+--alter table simple set (parallel_workers = 2);
+--analyze simple;
+--
+--drop table extremely_skewed;
+--create table extremely_skewed (id int, t text);
+--alter table extremely_skewed set (autovacuum_enabled = 'false');
+--alter table extremely_skewed set (parallel_workers = 2);
+--analyze extremely_skewed;
+--insert into extremely_skewed
+--  select 42 as id, 'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa'
+--  from generate_series(1, 20000);
+--update pg_class
+--  set reltuples = 2, relpages = pg_relation_size('extremely_skewed') / 8192
+--  where relname = 'extremely_skewed';
+
+--set work_mem=64;
+--set enable_mergejoin to off;
+--explain (analyze, costs off, timing off)
+  --select * from simple r join extremely_skewed s using (id);
+--select * from explain_multi_batch();
+
+drop table t1;
+drop table t2;
+drop function explain_multi_batch();
+reset enable_mergejoin;
+reset work_mem;
+reset search_path;
+drop schema adaptive_hj;
